package iface

import (
	mbase "github.com/multiformats/go-multibase"
	peer "gitlab.dms3.io/p2p/go-p2p-core/peer"
)

func FormatKeyID(id peer.ID) string {
	if s, err := peer.ToCid(id).StringOfBase(mbase.Base36); err != nil {
		panic(err)
	} else {
		return s
	}
}

// FormatKey formats the given DMS3NS key in a canonical way.
func FormatKey(key Key) string {
	return FormatKeyID(key.ID())
}
